"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/esnext.weak-map.delete-all.js");
require("core-js/modules/esnext.weak-map.emplace.js");
require("core-js/modules/web.dom-collections.for-each.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrButton = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
var _classnames = _interopRequireDefault(require("classnames"));
var _react = _interopRequireWildcard(require("react"));
require("./index.css");
var _popover = require("../popover");
var _icon = require("../icon");
var _type = require("../icon/type");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["block", "loading", "type", "shape", "styleType", "size", "preIcon", "preIconProps", "postIcon", "postIconProps", "disabled", "onClick", "extra", "className", "onHover"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var FcrButton = exports.FcrButton = function FcrButton(props) {
  var block = props.block,
    loading = props.loading,
    _props$type = props.type,
    type = _props$type === void 0 ? 'primary' : _props$type,
    _props$shape = props.shape,
    shape = _props$shape === void 0 ? 'rounded' : _props$shape,
    styleType = props.styleType,
    _props$size = props.size,
    size = _props$size === void 0 ? 'L' : _props$size,
    preIcon = props.preIcon,
    preIconProps = props.preIconProps,
    postIcon = props.postIcon,
    postIconProps = props.postIconProps,
    disabled = props.disabled,
    _onClick = props.onClick,
    extra = props.extra,
    className = props.className,
    onHover = props.onHover,
    otherProps = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    hover = _useState2[0],
    setHover = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    extraPopoverVisible = _useState4[0],
    setExtraPopoverVisible = _useState4[1];
  var _useState5 = (0, _react.useState)(false),
    _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
    extraHover = _useState6[0],
    setExtraHover = _useState6[1];
  var iconColor = styleType === 'white' ? type === 'primary' ? hover ? "var(--)" : "var(--)" : undefined : undefined;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("button", _objectSpread(_objectSpread({
    onMouseEnter: function onMouseEnter() {
      if (disabled) return;
      setHover(true);
      onHover === null || onHover === void 0 || onHover(true);
    },
    onMouseLeave: function onMouseLeave() {
      if (disabled) return;
      setHover(false);
      onHover === null || onHover === void 0 || onHover(false);
    }
  }, otherProps), {}, {
    onClick: function onClick() {
      return !disabled && (_onClick === null || _onClick === void 0 ? void 0 : _onClick());
    },
    className: (0, _classnames["default"])('fcr-button', "fcr-button-".concat(type), "fcr-button-".concat(shape), "fcr-button-".concat(size), 'fcr-btn-click-effect', (0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])((0, _defineProperty2["default"])({}, "fcr-button-".concat(styleType), !!styleType), 'fcr-button-icon-only', !props.children), 'fcr-button-block', block), 'fcr-button-with-extra', extra), 'fcr-button-extra-active', (extra === null || extra === void 0 ? void 0 : extra.visible) || extraPopoverVisible || extraHover), 'fcr-button-disabled', disabled), className),
    children: [preIcon && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-button-icon fcr-button-preicon",
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, _objectSpread({
        type: preIcon
      }, preIconProps))
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("p", {
      children: props.children
    }), extra && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-button-extra fcr-divider",
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_popover.FcrPopover, _objectSpread(_objectSpread({
        trigger: "click",
        showArrow: true,
        visible: extraPopoverVisible,
        mouseEnterDelay: 0,
        onVisibleChange: setExtraPopoverVisible
      }, extra), {}, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          onMouseEnter: function onMouseEnter() {
            setExtraHover(true);
          },
          onMouseLeave: function onMouseLeave() {
            setExtraHover(false);
          },
          onClick: function onClick(e) {
            e.preventDefault();
            e.stopPropagation();
          },
          className: (0, _classnames["default"])('fcr-button-extra-inner', {
            'fcr-button-extra-inner-active': (extra === null || extra === void 0 ? void 0 : extra.visible) || extraPopoverVisible || extraHover
          }),
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
            type: _type.FcrIconType.FCR_MORE2
          })
        })
      }))
    }), (loading || postIcon) && !extra && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, _objectSpread({
        className: (0, _classnames["default"])('fcr-button-icon fcr-button-posticon', {
          'fcr-button-loading': loading
        }),
        type: loading ? _type.FcrIconType.FCR_BTN_LOADING : postIcon
      }, postIconProps))
    })]
  }));
};