import { FC, ReactNode } from 'react';
import { ButtonProps } from '../button';
import { FcrIconType } from '../icon/type';
import './index.css';
export interface ConfirmContentProps {
    /**
     * 对话框关闭的回调，点击关闭按钮或蒙层时触发
     */
    /** @en
     * Specify a function that will be called when a user clicks mask, close button on top right or Cancel button
     */
    onClose?: () => void;
    /**
     * 对话框宽度
     */
    /** @en
     * Width of the dialog
     */
    width?: number;
    /**
    /** @en
     * Height of the dialog
     */
    height?: number;
    /**
     * 是否显示对话框关闭按钮
     */
    /** @en
     * Whether a close (x) button is visible on top right of the dialog or not
     */
    closable?: boolean;
    /**
     * 自定义对话框关闭按钮
     */
    /** @en
     * Custom close icon
     */
    closeIcon?: ReactNode;
    showCancel?: boolean;
    showOk?: boolean;
    icon?: FcrIconType;
    title?: string;
    content: string | JSX.Element;
    cancelText?: string;
    okText?: string;
    alignCenter?: boolean;
    onOk?: () => void;
    onCancel?: () => void;
    cancelButtonProps?: ButtonProps;
    okButtonProps?: ButtonProps;
    reverseButton?: boolean;
}
declare const ConfirmContent: FC<React.PropsWithChildren<ConfirmContentProps>>;
export { ConfirmContent };
