import React from 'react';
import './index.css';
export type DevicePretestSettingKey = 'Video' | 'Audio' | 'VirtualBg' | 'Beauty' | 'Mirror';
export interface FcrDevicePretestPageProps {
    nickName?: string;
    meetingInfo?: {
        meetingName?: string;
        meetingHostName?: string;
    };
    videoInfos: {
        noCamera?: boolean;
        noMicrophone?: boolean;
        enableVideo?: boolean;
        enableAudio?: boolean;
        enableVirtualBg?: boolean;
        enableBeauty?: boolean;
        enableMirror?: boolean;
        leftRotationAngle?: 90 | 180 | 270 | 360;
        microphonePercentage?: number;
    };
    handleAction?: () => void;
    videoPlayer: React.ReactNode;
    updateSetting?: (key: DevicePretestSettingKey) => void;
    speakerElement?: React.ReactNode;
    showCameraPreview?: boolean;
}
export declare const FcrDevicePretestPage: React.FC<React.PropsWithChildren<FcrDevicePretestPageProps>>;
export declare const SpeakerPhoneTest: React.FC<{
    lastVolumePercentage: number;
}>;
