"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AudioSettings = void 0;
require("core-js/modules/es.array.map.js");
require("core-js/modules/es.number.constructor.js");
require("core-js/modules/es.number.to-fixed.js");
require("core-js/modules/esnext.async-iterator.map.js");
require("core-js/modules/esnext.iterator.map.js");
require("core-js/modules/web.timers.js");
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _useNamespace = require("../common/useNamespace");
require("./index.css");
var _advanceLink = require("../common/advance-link");
var _classnames = _interopRequireDefault(require("classnames"));
var _microphoneDetection = require("./microphone-detection");
var _speakerDetection = require("./speaker-detection");
var _volumeIndicator = require("../../volume-indicator");
var _slider = require("../../slider");
var _checkbox = require("../../checkbox");
var _radio = require("../../radio");
var _switch = require("../../switch");
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var AudioSettings = exports.AudioSettings = function AudioSettings() {
  var ns = (0, _useNamespace.useNamespace)('device-settings-audio');
  var t = (0, _i18n.useI18n)();
  var _useState = (0, _react.useState)(0.2),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    outputLevel = _useState2[0],
    setOutputLevel = _useState2[1];
  var _useState3 = (0, _react.useState)(0.2),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    outputVolume = _useState4[0],
    setOutputVolume = _useState4[1];
  var _useState5 = (0, _react.useState)(true),
    _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
    autoAdjustmentSpeakerVolume = _useState6[0],
    setAutoAdjustmentSpeakerVolume = _useState6[1];
  var _useState7 = (0, _react.useState)(0.2),
    _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
    inputLevel = _useState8[0],
    setInputLevel = _useState8[1];
  var _useState9 = (0, _react.useState)(0.2),
    _useState10 = (0, _slicedToArray2["default"])(_useState9, 2),
    inputVolume = _useState10[0],
    setInputVolume = _useState10[1];
  var _useState11 = (0, _react.useState)(true),
    _useState12 = (0, _slicedToArray2["default"])(_useState11, 2),
    autoAdjustmentMicrophoneVolume = _useState12[0],
    setAutoAdjustmentMicrophoneVolume = _useState12[1];
  var _useState13 = (0, _react.useState)('auto'),
    _useState14 = (0, _slicedToArray2["default"])(_useState13, 2),
    noiseReduce = _useState14[0],
    setNoiseReduce = _useState14[1];
  var _useState15 = (0, _react.useState)(true),
    _useState16 = (0, _slicedToArray2["default"])(_useState15, 2),
    showTurnOnAcoustic = _useState16[0],
    setShowTurnOnAcoustic = _useState16[1];
  (0, _react.useEffect)(function () {
    var timer = setInterval(function () {
      setOutputLevel(Number(Math.random().toFixed(2)));
    }, 500);
    return function () {
      return clearInterval(timer);
    };
  }, []);
  (0, _react.useEffect)(function () {
    var timer = setInterval(function () {
      setInputLevel(Number(Math.random().toFixed(2)));
    }, 500);
    return function () {
      return clearInterval(timer);
    };
  }, []);
  var noiseReduceOptions = (0, _react.useMemo)(function () {
    return [{
      label: t('fmt_internalsetting_label_automatic'),
      value: 'auto'
    }, {
      label: t('fmt_setting_option_3alow'),
      addition: t('fmt_internalsetting_tips_backgroundsound'),
      value: 'low'
    }, {
      label: t('fmt_setting_option_3amoderate'),
      addition: t('fmt_internalsetting_tips_fanpan'),
      value: 'medium'
    }, {
      label: t('fmt_setting_option_3ahigh'),
      addition: t('fmt_internalsetting_tips_dogbarking'),
      value: 'high'
    }];
  }, [t]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: ns.b(),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _classnames["default"])(ns.e('section'), ns.e('section-speaker')),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('section-title'),
        children: t('fmt_setting_label_Speaker')
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('detection-wrapper'),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_speakerDetection.SpeakerDetection, {})
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: ns.e('form-item'),
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: ns.e('form-label'),
          children: t('fmt_setting_label_oututlevel')
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_volumeIndicator.FcrVolumeIndicator, {
          value: outputLevel,
          barCount: 13
        })]
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: ns.e('form-item'),
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: ns.e('form-label'),
          children: t('fmt_setting_label_volume')
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_slider.FcrSlider, {
          value: outputVolume,
          min: 0,
          max: 1,
          step: 0.01,
          onChange: function onChange(v) {
            return setOutputVolume(v);
          }
        })]
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.em('checkbox-wrapper', 'bordered'),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
          size: "small",
          label: t('fmt_additional_options_speakerautoadjust'),
          checked: autoAdjustmentSpeakerVolume,
          onChange: function onChange(v) {
            return setAutoAdjustmentSpeakerVolume(v);
          }
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _classnames["default"])(ns.e('section'), ns.e('section-microphones')),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('section-title'),
        children: t('fmt_setting_label_Speaker')
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('detection-wrapper'),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_microphoneDetection.MicrophoneDetection, {})
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: ns.e('form-item'),
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: ns.e('form-label'),
          children: t('fmt_internalsetting_label_inputlevel')
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_volumeIndicator.FcrVolumeIndicator, {
          value: inputLevel,
          barCount: 13
        })]
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: ns.e('form-item'),
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: ns.e('form-label'),
          children: t('fmt_internalsetting_label_inputvolume')
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_slider.FcrSlider, {
          value: inputVolume,
          min: 0,
          max: 1,
          step: 0.01,
          onChange: function onChange(v) {
            return setInputVolume(v);
          }
        })]
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.em('checkbox-wrapper', 'bordered'),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
          size: "small",
          label: t('fmt_additional_options_micautoadjust'),
          checked: autoAdjustmentMicrophoneVolume,
          onChange: function onChange(v) {
            return setAutoAdjustmentMicrophoneVolume(v);
          }
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _classnames["default"])(ns.e('section'), ns.e('section-reduce-noise')),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('section-title'),
        children: t('fmt_additional_label_reducenoise')
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_radio.FcrRadioGroup, {
        value: noiseReduce,
        onChange: function onChange(value) {
          return setNoiseReduce(value);
        },
        children: noiseReduceOptions.map(function (item) {
          return /*#__PURE__*/(0, _jsxRuntime.jsx)(_radio.FcrRadio, {
            value: item.value,
            label: /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
              children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
                children: item.label
              }), item.addition && /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
                className: ns.e('radio-label-addition'),
                children: ["\uFF08", item.addition, "\uFF09"]
              })]
            })
          }, item.value);
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _classnames["default"])(ns.e('section'), ns.e('section-pro-audio')),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('section-title'),
        children: t('fmt_setting_label_professional')
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_switch.FcrSwitch, {}), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: ns.e('section-title'),
          children: t('fmt_settings_options_enableoptions')
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
          size: "small",
          label: t('fmt_settings_options_highquality'),
          checked: false,
          onChange: function onChange(v) {
            return setShowTurnOnAcoustic(v);
          }
        })]
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_advanceLink.AdvanceLink, {})]
  });
};