"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MicrophoneDetection = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _useNamespace = require("../common/useNamespace");
var _select = require("../../select");
var _tooltip = require("../../tooltip");
var _button = require("../../button");
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var MicrophoneDetection = exports.MicrophoneDetection = function MicrophoneDetection() {
  var ns = (0, _useNamespace.useNamespace)('microphone-detection');
  var t = (0, _i18n.useI18n)();
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    isDetecting = _useState2[0],
    setIsDetecting = _useState2[1];
  var _useState3 = (0, _react.useState)(undefined),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    microphoneDeviceId = _useState4[0],
    setMicrophoneDeviceId = _useState4[1];
  var microphoneDevicesList = [{
    text: 'Device1',
    value: '1'
  }, {
    text: 'Device2',
    value: '2'
  }, {
    text: 'Device3',
    value: '3'
  }];
  var setMicrophoneDevice = function setMicrophoneDevice(id) {
    setMicrophoneDeviceId(id);
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: ns.b(),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_select.FcrSelect, {
      options: microphoneDevicesList,
      value: microphoneDeviceId,
      onChange: setMicrophoneDevice,
      disabled: microphoneDevicesList.length === 0,
      placeholder: t('fmt_uimanager_labels_deviceselect') // 请选择设备
      ,
      size: "small",
      styleType: "white"
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip.FcrToolTip, {
      trigger: "hover",
      placement: "top",
      mouseEnterDelay: 0.2,
      content: t(isDetecting ? 'fmt_setting_tips_speaker_unwork' : 'fmt_setting_tips_mic'),
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_button.FcrButton, {
        onClick: function onClick() {
          return setIsDetecting(!isDetecting);
        },
        size: "XS"
        // loading={loading}
        ,
        disabled: !microphoneDeviceId,
        type: "secondary-bordered",
        shape: "rounded",
        children: t(isDetecting ? 'fmt_record_tips_recording' : 'fmt_setting_button_Mic')
      })
    })]
  });
};