"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DialogWrapper = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _useNamespace = require("./common/useNamespace");
var _button = require("../button");
var _dialog = require("../dialog");
var _icon = require("../icon");
var _type = require("../icon/type");
var _i18n = require("../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var DialogWrapper = exports.DialogWrapper = function DialogWrapper(props) {
  var t = (0, _i18n.useI18n)();
  var ns = (0, _useNamespace.useNamespace)('device-settings');
  var _useState = (0, _react.useState)(true),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    deviceSettingDialogVisible = _useState2[0],
    setDeviceSettingDialogVisible = _useState2[1];
  var onClose = function onClose() {
    setDeviceSettingDialogVisible(false);
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_button.FcrButton, {
      onClick: function onClick() {
        return setDeviceSettingDialogVisible(true);
      },
      children: t('fmt_setting_label_setting')
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)(_dialog.BaseDialog, {
      destroyOnClose: true,
      width: 530,
      wrapClassName: ns.e('dialog'),
      visible: deviceSettingDialogVisible,
      maskClosable: false,
      closable: false,
      onClose: onClose,
      children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: ns.e('dialog-header'),
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: ns.e('dialog-title'),
          children: t('fmt_setting_label_setting')
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
          onClick: onClose,
          className: ns.e('dialog-close'),
          type: _type.FcrIconType.FCR_CLOSE,
          colors: {
            iconPrimary: 'var(--fcr_ui_scene_icontext1)'
          },
          size: 14
        })]
      }), props.children]
    })]
  });
};