"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MirrorToggle = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _useNamespace = require("../common/useNamespace");
var _type = require("../../icon/type");
var _tooltip = require("../../tooltip");
var _icon = require("../../icon");
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var MirrorToggle = exports.MirrorToggle = function MirrorToggle() {
  var ns = (0, _useNamespace.useNamespace)('device-settings-mirror-toggle');
  var t = (0, _i18n.useI18n)();
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    isLocalMirrorEnabled = _useState2[0],
    setIsLocalMirrorEnabled = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    isIconHovered = _useState4[0],
    setIsIconHovered = _useState4[1];
  var iconType = (0, _react.useMemo)(function () {
    return isLocalMirrorEnabled ? _type.FcrIconType.FCR_MIRRORIMAGE_LEFT : _type.FcrIconType.FCR_MIRRORIMAGE_RIGHT;
  }, [isLocalMirrorEnabled]);
  var iconColors = (0, _react.useMemo)(function () {
    return isIconHovered ? {
      iconPrimary: 'var(--fcr_web_ui_scene_mainicon2)'
    } : {
      iconPrimary: 'var(--fcr_web_ui_scene_mainicon1)'
    };
  }, [isIconHovered]);
  var toggleLocalMirror = function toggleLocalMirror() {
    setIsLocalMirrorEnabled(!isLocalMirrorEnabled);
  };
  var onMouseEnter = function onMouseEnter() {
    setIsIconHovered(true);
  };
  var onMouseLeave = function onMouseLeave() {
    setIsIconHovered(false);
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip.FcrToolTip, {
    trigger: "hover",
    placement: "top",
    mouseEnterDelay: 0.2,
    content: t('fmt_uimanager_labels_mirror'),
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      onMouseEnter: onMouseEnter,
      onMouseLeave: onMouseLeave,
      onClick: toggleLocalMirror,
      className: ns.b(),
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: iconType,
        colors: iconColors,
        size: 20
      })
    })
  });
};