"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VideoSettingsBasic = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _useNamespace = require("../common/useNamespace");
var _advanceLink = require("../common/advance-link");
var _checkbox = require("../../checkbox");
var _radio = require("../../radio");
var _classnames = _interopRequireDefault(require("classnames"));
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var VideoSettingsBasic = exports.VideoSettingsBasic = function VideoSettingsBasic() {
  var ns = (0, _useNamespace.useNamespace)('video-settings-basic');
  var t = (0, _i18n.useI18n)();
  var _useState = (0, _react.useState)(true),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    shouldTurnOffVideo = _useState2[0],
    setShouldTurnOffVideo = _useState2[1];
  var _useState3 = (0, _react.useState)(true),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    shouldDisplayPreviewDialog = _useState4[0],
    setShouldDisplayPreviewDialog = _useState4[1];
  var _useState5 = (0, _react.useState)(true),
    _useState6 = (0, _slicedToArray2["default"])(_useState5, 2),
    shouldHideNonVideoParticipants = _useState6[0],
    setShouldHideNonVideoParticipants = _useState6[1];
  var _useState7 = (0, _react.useState)('16'),
    _useState8 = (0, _slicedToArray2["default"])(_useState7, 2),
    displayedMaxAttendees = _useState8[0],
    setDisplayedMaxAttendees = _useState8[1];
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: ns.b(),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: ns.e('basic-form'),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        size: "small",
        label: t('fmt_internalsetting_options_closevideojoin'),
        checked: shouldTurnOffVideo,
        onChange: function onChange(v) {
          return setShouldTurnOffVideo(v);
        }
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        size: "small",
        label: t('fmt_internalsetting_options_alwaysbox'),
        checked: shouldDisplayPreviewDialog,
        onChange: function onChange(v) {
          return setShouldDisplayPreviewDialog(v);
        }
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        size: "small",
        label: t('fmt_internalsetting_options_hidenonvideo'),
        checked: shouldHideNonVideoParticipants,
        onChange: function onChange(v) {
          return setShouldHideNonVideoParticipants(v);
        }
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _classnames["default"])(ns.e('basic-form'), ns.e('max-person-form')),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('max-person-label'),
        children: t('fmt_internalsetting_options_maximumdisplay')
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('max-person-radio-group'),
        children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(_radio.FcrRadioGroup, {
          value: displayedMaxAttendees,
          onChange: function onChange(v) {
            return setDisplayedMaxAttendees(v);
          },
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_radio.FcrRadio, {
            value: "16",
            label: t('fmt_internalsetting_options_16')
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_radio.FcrRadio, {
            value: "25",
            label: t('fmt_internalsetting_options_25')
          })]
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_advanceLink.AdvanceLink, {})]
  });
};