"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VideoSettings = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _useNamespace = require("../common/useNamespace");
var _videoSettingsBasic = require("./video-settings-basic");
var _mirrorToggle = require("./mirror-toggle");
var _localVideoPlayer = require("./local-video-player");
var _cameraSelect = require("./camera-select");
require("./index.css");
var _tabs = require("../../tabs");
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var tabContents = {
  basic: /*#__PURE__*/(0, _jsxRuntime.jsx)(_videoSettingsBasic.VideoSettingsBasic, {}),
  'virtual-background': /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    children: "virtual-background"
  }),
  'beauty-filter': /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    children: "beauty-filter"
  })
};
var VideoSettings = exports.VideoSettings = function VideoSettings() {
  var ns = (0, _useNamespace.useNamespace)('device-settings-video');
  var t = (0, _i18n.useI18n)();
  var tabItems = [{
    label: t('fmt_setting_option_basics'),
    key: 'basic'
  }, {
    label: t('fmt_setting_option_backgrounds'),
    key: 'virtual-background'
  }, {
    label: t('fmt_device_labels_specialeffects'),
    key: 'beauty-filter'
  }];
  var _useState = (0, _react.useState)('basic'),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    activeTab = _useState2[0],
    setActiveTab = _useState2[1];
  var handleActiveTab = function handleActiveTab(tabKey) {
    setActiveTab(tabKey);
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: ns.b(),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: ns.e('header'),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        children: t('fmt_setting_label_preview')
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_mirrorToggle.MirrorToggle, {})]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: ns.e('preview'),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_localVideoPlayer.LocalVideoPlayer, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: ns.e('device-select'),
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_cameraSelect.CameraSelect, {})
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: ns.e('tab-wrapper'),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        style: {
          fontSize: 0
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_tabs.FcrFashionTabs, {
          items: tabItems,
          activeKey: activeTab,
          onChange: handleActiveTab
        })
      }), tabContents[activeTab]]
    })]
  });
};