"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DeviceSettingsView = void 0;
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _classnames = _interopRequireDefault(require("classnames"));
var _audioSettings = require("./audio-settings/audio-settings");
var _videoSettings = require("./video-settings/video-settings");
require("./index.css");
var _useNamespace = require("./common/useNamespace");
var _icon = require("../icon");
var _type = require("../icon/type");
var _i18n = require("../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var tabContents = {
  audio: /*#__PURE__*/(0, _jsxRuntime.jsx)(_audioSettings.AudioSettings, {}),
  video: /*#__PURE__*/(0, _jsxRuntime.jsx)(_videoSettings.VideoSettings, {})
};
var DeviceSettingsView = exports.DeviceSettingsView = function DeviceSettingsView() {
  var _useState = (0, _react.useState)('video'),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    activeTab = _useState2[0],
    setActiveTab = _useState2[1];
  var t = (0, _i18n.useI18n)();
  var ns = (0, _useNamespace.useNamespace)('device-settings');
  var getListItemCls = function getListItemCls(tabKey) {
    return (0, _classnames["default"])(ns.e('nav-list-item'), ns.is('active', activeTab === tabKey));
  };
  var getSurroundingCls = function getSurroundingCls(color) {
    return (0, _classnames["default"])(ns.e('surrounding'), ns.em('surrounding', color));
  };
  var tabClickHandler = function tabClickHandler(tabKey) {
    return function () {
      setActiveTab(tabKey);
    };
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: ns.b(),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: ns.e('nav'),
      children: /*#__PURE__*/(0, _jsxRuntime.jsxs)("ul", {
        children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("li", {
          className: getListItemCls('audio'),
          onClick: tabClickHandler('audio'),
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: getSurroundingCls('green'),
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
              type: _type.FcrIconType.FCR_MUTE,
              colors: {
                iconPrimary: 'white'
              },
              size: 24
            })
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            children: t('fmt_pstn_options_audio_setting')
          })]
        }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("li", {
          className: getListItemCls('video'),
          onClick: tabClickHandler('video'),
          children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: getSurroundingCls('purple'),
            children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
              type: _type.FcrIconType.FCR_CAMERA,
              colors: {
                iconPrimary: 'white'
              },
              size: 24
            })
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            children: t('fmt_setting_option_Video')
          })]
        })]
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: (0, _classnames["default"])(ns.e('tab-content-wrapper'), ns.is('tab-content-video-wrapper', activeTab === 'video')),
      children: tabContents[activeTab]
    })]
  });
};