import { FC, ReactNode } from 'react';
import { ButtonProps } from '../button';
import { BaseDialogProps } from '.';
import './class-dialog.css';
export interface ClassDialogProps extends BaseDialogProps {
    /**
     * 对话框标题
     */
    /** @en
     * The dialog Title.
     */
    title?: ReactNode;
    /**
     * 对话框底部元素
     */
    /** @en
     * Footer content
     */
    footer?: ReactNode;
    /**
     * 对话框顶部图片地址
     */
    /** @en
     * Set the url for the image on the top of dialog.
     */
    imgUrl?: string;
    /**
     * 对话框描述内容
     */
    /** @en
     * The dialog content
     */
    content?: ReactNode;
    /**
     * 对话框按钮组，会在描述内容下方渲染若干操作按钮
     */
    /** @en
     * Set the action buttons on the bottom of the dialog content.
     */
    actions?: (ButtonProps & {
        text?: string;
    })[];
    /**
     * 是否显示取消按钮
     */
    /** @en
     * Wheter the cancel button is visible on bottom of the dialog or not.
     */
    cancelBtn?: boolean;
}
export declare const FcrClassDialog: FC<React.PropsWithChildren<ClassDialogProps>>;
