import { FC, ReactNode } from 'react';
import { ButtonProps } from '../button';
import { CheckboxProps } from '../checkbox';
import { BaseDialogProps } from '.';
import './confirm-dialog.css';
export interface ConfirmDialogProps extends BaseDialogProps {
    /**
     * 对话框标题
     */
    /** @en
     * The dialog's title.
     */
    title?: ReactNode;
    /**
     * 对话框底部元素
     */
    /** @en
     * Footer content
     */
    footer?: ReactNode;
    /**
     * 点击对话框确认按钮回调
     */
    /** @en
     * Specify a function that will be called when a user clicks the OK button
     */
    onOk?: () => void;
    /**
     * 是否展示对话框checkbox
     */
    /** @en
     * Wheter the chekcbox is visibleon bottom left of the dialog or not.
     */
    checkable?: boolean;
    /**
     * 对话框checkbox属性
     */
    /** @en
     * The checkbox props.
     */
    checkedProps?: CheckboxProps;
    /**
     * 对话框确认按钮文案
     */
    /** @en
     * Text of the OK button
     */
    okText?: ReactNode;
    /**
     * 对话框取消按钮文案
     */
    /** @en
     * Text of the cancel button
     */
    cancelText?: ReactNode;
    /**
     * 对话框图标
     */
    /** @en
     * Set the icon on the left of the dialog title and content.
     */
    icon?: ReactNode;
    content?: ReactNode;
    okButtonProps?: ButtonProps;
    cancelButtonProps?: ButtonProps;
    okButtonVisible?: boolean;
    cancelButtonVisible?: boolean;
    onCancel?: () => void;
}
export declare const FcrConfirmDialog: FC<React.PropsWithChildren<ConfirmDialogProps>>;
