import { FC, ReactNode } from 'react';
import './index.css';
export interface MenuData {
    title: ReactNode;
    key: string;
    icon?: ReactNode;
    onButtonClick?: () => void;
    classNames?: string;
    type?: 'primary' | 'danger' | 'title' | 'disabled' | 'group';
    [key: string]: any;
}
export interface FcrDropMenuProps {
    title?: ReactNode;
    styles?: {
        titleStyle?: React.CSSProperties;
        menuStyle?: React.CSSProperties;
    };
    footer?: ReactNode;
    options?: MenuData[];
    children?: ReactNode;
    className?: string;
}
export declare const FcrDropOption: FC<MenuData>;
export declare const FcrDropMenu: FC<FcrDropMenuProps>;
