"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrDropOption = exports.FcrDropMenu = void 0;
require("core-js/modules/es.array.map.js");
require("core-js/modules/esnext.async-iterator.map.js");
require("core-js/modules/esnext.iterator.map.js");
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
require("./index.css");
var _classnames2 = _interopRequireDefault(require("classnames"));
var _icon = require("../icon");
var _type = require("../icon/type");
var _jsxRuntime = require("react/jsx-runtime");
var _react = require("react");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var FcrDropOption = exports.FcrDropOption = function FcrDropOption(option) {
  var _option$type = option.type,
    type = _option$type === void 0 ? 'primary' : _option$type,
    loading = option.loading;
  if (type === 'title') {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-drop-menu-title",
      children: option.title
    });
  }
  if (type === 'group') {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-drop-menu-group",
      children: option.title
    });
  }
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: (0, _classnames2["default"])(option.classNames, 'fcr-drop-menu-option', (0, _defineProperty2["default"])({}, "fcr-drop-menu-option-".concat(type), !!type), {
      'fcr-drop-menu-option-disabled': option.disabled
    }),
    onClick: !option.disabled ? option.onButtonClick : undefined,
    children: [option.icon, /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      className: "fcr-drop-menu-option-text",
      children: option.title
    }), loading && /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      className: (0, _classnames2["default"])('fcr-drop-menu-item-icon', {
        'fcr-drop-menu-item-loading': loading
      }),
      type: _type.FcrIconType.FCR_BTN_LOADING
    })]
  });
};
var FcrDropMenu = exports.FcrDropMenu = function FcrDropMenu(props) {
  var title = props.title,
    options = props.options,
    children = props.children,
    styles = props.styles,
    className = props.className;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: (0, _classnames2["default"])('fcr-drop-menu', className),
    children: [title && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-drop-menu-title",
      children: title
    }), options && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-drop-menu-options",
      children: options.map(function (option, index) {
        return /*#__PURE__*/(0, _react.createElement)(FcrDropOption, _objectSpread(_objectSpread({}, option), {}, {
          key: "drop_".concat(index)
        }));
      })
    }), children]
  });
};