"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Basic = void 0;
var _index = require("./index");
var _type = require("../icon/type");
var _icon = require("../icon");
var _jsxRuntime = require("react/jsx-runtime");
var meta = {
  title: 'Components/DropMenu',
  tags: ['autodocs'],
  argTypes: {
    title: {
      control: 'text',
      defaultValue: 'title'
    },
    options: {
      control: 'object',
      defaultValue: [{
        title: 'Option 1',
        key: '1',
        icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
          type: _type.FcrIconType.FCR_LOWER_HAND
        }),
        onButtonClick: function onButtonClick() {
          console.log('Option 1');
        }
      }, {
        title: 'Option 2',
        key: '2',
        onButtonClick: function onButtonClick() {
          console.log('Option 2');
        }
      }]
    },
    children: {
      control: 'text',
      defaultValue: 'children'
    },
    styles: {
      control: 'object',
      defaultValue: {
        titleStyle: {
          color: 'red'
        },
        menuStyle: {
          color: 'blue'
        }
      }
    }
  }
};
var Basic = exports.Basic = {
  args: {
    title: 'title',
    options: [{
      title: 'Option 1',
      key: '1',
      icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: _type.FcrIconType.FCR_LOWER_HAND,
        size: 20,
        colors: {
          iconPrimary: 'var(--fcr_ui_scene_icontext5)',
          iconSecondary: 'var(--fcr_ui_scene_ramp_red6)'
        }
      }),
      onButtonClick: function onButtonClick() {
        console.log('Option 1');
      }
    }, {
      title: 'Option 2',
      key: '2',
      onButtonClick: function onButtonClick() {
        console.log('Option 2');
      }
    }, {
      title: 'Option 3',
      key: '3',
      type: 'danger',
      onButtonClick: function onButtonClick() {
        console.log('Option 2');
      }
    }],
    children: 'children'
  },
  render: function render(props) {
    var title = props.title,
      options = props.options,
      children = props.children,
      styles = props.styles;
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      style: {
        display: 'flex',
        padding: 20
      },
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_index.FcrDropMenu, {
        title: title,
        options: options,
        styles: styles,
        children: children
      })
    });
  }
};
var _default = exports["default"] = meta;