import React, { CSSProperties } from 'react';
import './index.css';
import { FcrIconType } from '../icon/type';
import { FcrIconProps } from '../icon';
export interface IconTextProps {
    icon: FcrIconType;
    styles?: CSSProperties;
    fontSize?: 'small' | 'medium' | 'large';
    colors?: FcrIconProps['colors'];
    txt?: string;
    iconTransform?: boolean;
    classnames?: {
        [key: string]: boolean;
    };
    isHideIcon?: boolean;
    /**
     * 支持点击
     */
    enable?: boolean;
    onClick?: () => void;
    /**
     * icon 和 text 换顺序
     */
    iconReverse?: boolean;
}
export declare const IconText: React.FC<React.PropsWithChildren<IconTextProps>>;
