import { FC } from 'react';
import './index.css';
export type InputNumberProps = {
    /**
     * 输入框的提示符
     */
    /** @en
     * Placeholder of the input box
     */
    placeholder?: string;
    /**
     * 输入框中的值
     */
    /** @en
     * Value of the input box
     */
    value?: number;
    /**
     * 每次点变更的值
     */
    /**@en
     * the value that changes each time click
     */
    step?: number;
    /**
     * 输入框最小值
     */
    /** @en
     * Min value of the input
     */
    min?: number;
    /**
     * 输入框最大值
     */
    /** @en
     * Max value of the input
     */
    max?: number;
    /**
     * 输入框是否禁用
     */
    /** @en
     * Whether the input box is disabled
     */
    disabled?: boolean;
    /**
     * 输入框的尺寸：
     * small - 小
     * medium - 中等(default)
     * large - 大
     */
    /** @en
     * Size of the input box:
     * small
     * medium(default)
     * large
     */
    size?: 'large' | 'medium' | 'small';
    /**
     * 值变更事件
     * @param value 变更值
     */
    /** @en
     * Change event of the input's value
     * @param value changed value
     */
    onChange?: (value: number | null) => void;
};
export declare const FcrInputNumber: FC<InputNumberProps>;
