import './index.css';
export declare const DEFAULT_BEAUTY_VALUE = 50;
export declare enum VideoViewType {
    CAMERA_VIEW = "camera",
    SELFIE_VIEW = "selfie"
}
export interface LocalVideoPlayerProps {
    isLocalMirrorEnabled?: boolean;
    userName?: string;
    showSlider?: boolean;
    handleResetBeautyValueChange?: () => void;
    handleBeautyValueChange?: (value: number) => void;
    currentEditValue?: number;
    containerDom?: HTMLDivElement | null;
    setVideoOrientation?: () => void;
    cameraDeviceId?: string;
    showCameraPreview?: boolean;
    showTopTips?: boolean;
    startLocalVideo: (view: HTMLDivElement) => void;
    stopLocalVideo: (view: HTMLDivElement) => void;
    handleVideoViewChange?: (key: VideoViewType) => void;
    currentVideoViewType?: VideoViewType;
    showRotation?: boolean;
}
export declare const LocalVideoPlayer: React.FC<LocalVideoPlayerProps>;
export declare const VideoOrientation: React.FC<{
    setVideoOrientation: () => void;
}>;
export default LocalVideoPlayer;
