"use strict";

require("core-js/modules/es.array.iterator.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/es.string.iterator.js");
require("core-js/modules/es.weak-map.js");
require("core-js/modules/esnext.weak-map.delete-all.js");
require("core-js/modules/esnext.weak-map.emplace.js");
require("core-js/modules/web.dom-collections.iterator.js");
var _typeof = require("@babel/runtime/helpers/typeof");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.processEmojiTextMsg = processEmojiTextMsg;
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.array.index-of.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.array.slice.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.regexp.exec.js");
require("core-js/modules/es.string.includes.js");
require("core-js/modules/esnext.array.last-index.js");
var svgExports = _interopRequireWildcard(require("../icon/svg-exports"));
var _jsxRuntime = require("react/jsx-runtime");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var emojiMap = Object.keys(svgExports);

/**
 *
 * @param msg
 * @description 文本消息处理，将表情文本转换为表情图片，返回 ReactNode
 * @returns
 */
function processEmojiTextMsg(msg, className) {
  var inputString = msg;
  if (!inputString) {
    return null;
  }

  // 表情图片
  var imgTemplate = function imgTemplate(content) {
    return (
      /*#__PURE__*/
      // TODO: 需要替换为真实的表情图片
      (0, _jsxRuntime.jsx)(_jsxRuntime.Fragment, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)("img", {
          style: {
            display: 'inline-block',
            height: 24,
            width: 24
          },
          src: "https://www.baidu.com/img/PCtm_d9c8750bed0b3c7d089fa7d55720d6cf.png"
        })
      })
    );
  };

  // 文本
  var txtTemplate = function txtTemplate(content) {
    return /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
      children: content
    });
  };
  var pattern = /\[([a-zA-Z0-9_]+)\]/g;
  var msgElements = [];
  var lastPos = 0;
  var match;
  while ((match = pattern.exec(inputString)) !== null) {
    var start = match.index;
    var end = pattern.lastIndex;
    var emojiName = match[1];

    // TODO: 连调后删除
    // console.log({ msg, inputString, emojiName }, 'processEmojiTextMsg - while');
    // 匹配表情前的文本
    var prefixStr = inputString.slice(lastPos, start);
    prefixStr.length > 0 && msgElements.push(txtTemplate(prefixStr));

    // 存在 emoji
    if (emojiMap.includes(emojiName)) {
      msgElements.push(imgTemplate(emojiMap[emojiMap.indexOf(emojiName)]));
    } else {
      // 当作普通文本处理
      var contentStr = inputString.slice(start, end);
      contentStr.length > 0 && msgElements.push(txtTemplate(contentStr));
    }
    lastPos = end;
  }
  var suffixStr = inputString.slice(lastPos);
  // 匹配表情后剩余文本
  suffixStr.length > 0 && msgElements.push(txtTemplate(suffixStr));

  // console.log({ result: msgElements }, ' processEmojiTextMsg function');
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: className,
    children: msgElements
  });
}