"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Doc = void 0;
var _ = require(".");
var _jsxRuntime = require("react/jsx-runtime");
var meta = {
  title: 'Components/MessageBubble',
  tags: ['autodocs'],
  component: _.MessageBubble,
  args: {
    styles: {
      display: 'flex'
    },
    role: 'host',
    msg: 'Hello World!',
    isSelf: false
  },
  argTypes: {}
};
var Doc = exports.Doc = function Doc(props) {
  var role = props.role,
    msg = props.msg,
    isSelf = props.isSelf;
  var handleSelect = function handleSelect(val) {
    alert('Copied value: ' + val);
  };
  var customMsg_1 = 'Hello World!';
  var customMsg_2 = 'Hello World Hello World Hello World Hello World Hello World Hello World Hello World Hello World Hello World Hello World Hello World Hello WorldHello World Hello World Hello World Hello World Hello Wor';
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    style: {
      display: 'flex',
      flexDirection: 'column',
      padding: 50,
      border: 'solid 0.5px #e5e7eb'
    },
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        width: 320,
        maxWidth: 620,
        minWidth: 320,
        marginBottom: 50
      },
      children: ["Basic:", /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
        role: role,
        msg: msg,
        isSelf: isSelf
      })]
    }), "Please Change Properties:", /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        width: 320,
        maxWidth: 620,
        minWidth: 320,
        marginBottom: 50
      },
      children: ["Change role to \"other\": \"(direction is the right, embed false)\"", /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          msg: customMsg_1,
          onCopy: handleSelect
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        width: 320,
        maxWidth: 620,
        minWidth: 320,
        marginBottom: 50
      },
      children: ["Change isSelf to \"true\": \"(direction is the left, embed false)\"", /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          isSelf: true,
          styles: {
            position: 'relative'
          },
          role: 'participant',
          msg: customMsg_1,
          onCopy: handleSelect
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        width: 320,
        maxWidth: 620,
        minWidth: 320,
        marginBottom: 50
      },
      children: ["Change role to \"other\": \"(direction is the right, embed true)\"", /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        style: {
          display: 'flex'
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          msg: customMsg_2,
          onCopy: handleSelect
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        width: 320,
        maxWidth: 620,
        minWidth: 320,
        marginBottom: 50
      },
      children: ["Change isSelf to \"true\": \"(direction is the left, embed true)\"", /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        style: {
          display: 'flex'
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          isSelf: true,
          msg: customMsg_2,
          onCopy: handleSelect
        })
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      style: {
        display: 'flex',
        flexDirection: 'column',
        padding: '50px 50px 0',
        border: 'solid 0.5px #e5e7eb',
        width: 320,
        maxWidth: 620,
        minWidth: 320,
        marginBottom: 50
      },
      children: ["Message Use Margin & the last one has no margin", /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        style: {
          display: 'flex',
          flexDirection: 'column',
          flex: 1
        },
        children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          role: 'host',
          marginBottom: "large"
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          msg: customMsg_1,
          marginBottom: "small",
          onCopy: handleSelect
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          msg: customMsg_1 + customMsg_1 + customMsg_1,
          marginBottom: "large",
          onCopy: handleSelect
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          isSelf: true,
          msg: customMsg_1 + customMsg_1,
          marginBottom: "small",
          onCopy: handleSelect
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          isSelf: true,
          msg: customMsg_1 + customMsg_1 + customMsg_1,
          marginBottom: "large",
          onCopy: handleSelect
        }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_.MessageBubble, {
          styles: {
            position: 'relative'
          },
          role: 'participant',
          msg: customMsg_1,
          onCopy: handleSelect
        })]
      })]
    })]
  });
};
var _default = exports["default"] = meta;