import { FC } from 'react';
import './index.css';
export interface User {
    userId: string;
    userName: string;
    avatar?: string;
    hasVideo: boolean;
    hasAudio: boolean;
    isHost: boolean;
    isMe?: boolean;
    isScreenSharing?: boolean;
    audioDeviceType: 'none' | 'computer-mic' | 'phone-mic';
    videoDeviceType: 'none' | 'computer-cam';
    userType: 'normal' | 'phone' | 'meeting-system';
    volume?: number;
    userRole?: number;
    isSpotlight?: boolean;
    isBoardActive?: boolean;
    allowedOperations?: string[];
    isPin?: boolean;
}
export declare enum ParticipantActionType {
    MUTE_AUDIO = "MUTE_AUDIO",
    UNMUTE_AUDIO = "UNMUTE_AUDIO",
    MUTE_VIDEO = "MUTE_VIDEO",
    UNMUTE_VIDEO = "UNMUTE_VIDEO",
    PRIVATE_CHAT = "PRIVATE_CHAT",
    KICK_OUT = "KICK_OUT",
    ADD_PIN = "ADD_PIN",
    REMOVE_PIN = "REMOVE_PIN",
    SET_AS_HOST = "SET_AS_HOST",
    SET_AS_CO_HOST = "SET_AS_CO_HOST",
    SET_AS_ATTENDEE = "SET_AS_ATTENDEE",
    RENAME = "RENAME",
    ALL_RECORDING_LOCAL_VIDEO = "ALL_RECORDING_LOCAL_VIDEO",
    PUT_IN_WAITING_ROOM = "PUT_IN_WAITING_ROOM",
    STOP_RAISE_HAND = "STOP_RAISE_HAND",
    SET_MAIN_SPEAKER = "SET_MAIN_SPEAKER",
    MERGE_VIDEO = "MERGE_VIDEO",
    RENAME_IN_MEETING = "RENAME_IN_MEETING"
}
export declare const enum FcrUserRole {
    HOST = 1,
    COHOST = 2,
    PARTICIPANT = 3,
    AUDIENCE = 4,
    OBSERVER = 5,
    ROBOT = 6
}
export type FcrUserRoleValue = 1 | 2 | 3 | 4 | 5 | 6;
export interface ParticipantsMoreActionsProps {
    isMe?: boolean;
    userId: string;
    hasVideo: boolean;
    hasAudio: boolean;
    onParticipantsButtonClick: (action: ParticipantActionType, userId: string) => void;
    userName: string;
    userRole: FcrUserRoleValue;
    isPin: boolean;
    hasPinnedStream: boolean;
    allowedOperations: string[];
    audioDeviceType: string;
    userType?: string;
    perspectiveType?: string;
    hideActions?: string[];
}
export interface IFcrParticipantProps extends User {
    perspectiveType: 'host' | 'attendee' | 'cohost';
    allowedOperations: string[];
    hasPinnedStream: boolean;
    isPin: boolean;
    onParticipantsButtonClick?: (action: ParticipantActionType, userId: string) => void;
}
export declare const FcrParticipant: FC<IFcrParticipantProps>;
