"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ParticipantActionType = exports.FcrUserRole = exports.FcrParticipant = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _react = require("react");
var _avatar = require("../../avatar");
var _popover = require("../../popover");
var _cameraState = require("../../room-screen-share-state-bar/camera-state");
var _microphoneState = require("../../room-screen-share-state-bar/microphone-state");
var _participantsMore = require("../participants-more");
require("./index.css");
var _type = require("../../icon/type");
var _icon = require("../../icon");
var _classnames = _interopRequireDefault(require("classnames"));
var _action = require("../../button/action");
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var ParticipantActionType = exports.ParticipantActionType = /*#__PURE__*/function (ParticipantActionType) {
  ParticipantActionType["MUTE_AUDIO"] = "MUTE_AUDIO";
  ParticipantActionType["UNMUTE_AUDIO"] = "UNMUTE_AUDIO";
  ParticipantActionType["MUTE_VIDEO"] = "MUTE_VIDEO";
  ParticipantActionType["UNMUTE_VIDEO"] = "UNMUTE_VIDEO";
  ParticipantActionType["PRIVATE_CHAT"] = "PRIVATE_CHAT";
  ParticipantActionType["KICK_OUT"] = "KICK_OUT";
  ParticipantActionType["ADD_PIN"] = "ADD_PIN";
  ParticipantActionType["REMOVE_PIN"] = "REMOVE_PIN";
  ParticipantActionType["SET_AS_HOST"] = "SET_AS_HOST";
  ParticipantActionType["SET_AS_CO_HOST"] = "SET_AS_CO_HOST";
  ParticipantActionType["SET_AS_ATTENDEE"] = "SET_AS_ATTENDEE";
  ParticipantActionType["RENAME"] = "RENAME";
  ParticipantActionType["ALL_RECORDING_LOCAL_VIDEO"] = "ALL_RECORDING_LOCAL_VIDEO";
  ParticipantActionType["PUT_IN_WAITING_ROOM"] = "PUT_IN_WAITING_ROOM";
  ParticipantActionType["STOP_RAISE_HAND"] = "STOP_RAISE_HAND";
  ParticipantActionType["SET_MAIN_SPEAKER"] = "SET_MAIN_SPEAKER";
  ParticipantActionType["MERGE_VIDEO"] = "MERGE_VIDEO";
  ParticipantActionType["RENAME_IN_MEETING"] = "RENAME_IN_MEETING";
  return ParticipantActionType;
}({});
var FcrUserRole = exports.FcrUserRole = /*#__PURE__*/function (FcrUserRole) {
  FcrUserRole[FcrUserRole["HOST"] = 1] = "HOST";
  FcrUserRole[FcrUserRole["COHOST"] = 2] = "COHOST";
  FcrUserRole[FcrUserRole["PARTICIPANT"] = 3] = "PARTICIPANT";
  FcrUserRole[FcrUserRole["AUDIENCE"] = 4] = "AUDIENCE";
  FcrUserRole[FcrUserRole["OBSERVER"] = 5] = "OBSERVER";
  FcrUserRole[FcrUserRole["ROBOT"] = 6] = "ROBOT";
  return FcrUserRole;
}({}); // 定义一个类型来表示该枚举的值类型
var FcrParticipant = exports.FcrParticipant = function FcrParticipant(props) {
  var userId = props.userId,
    _props$userName = props.userName,
    userName = _props$userName === void 0 ? '' : _props$userName,
    userRole = props.userRole,
    hasAudio = props.hasAudio,
    hasVideo = props.hasVideo,
    isHost = props.isHost,
    _props$isMe = props.isMe,
    isMe = _props$isMe === void 0 ? false : _props$isMe,
    perspectiveType = props.perspectiveType,
    _props$isScreenSharin = props.isScreenSharing,
    isScreenSharing = _props$isScreenSharin === void 0 ? false : _props$isScreenSharin,
    _props$onParticipants = props.onParticipantsButtonClick,
    onParticipantsButtonClick = _props$onParticipants === void 0 ? function () {} : _props$onParticipants,
    userType = props.userType,
    videoDeviceType = props.videoDeviceType,
    audioDeviceType = props.audioDeviceType,
    allowedOperations = props.allowedOperations,
    hasPinnedStream = props.hasPinnedStream,
    isPin = props.isPin;
  var t = (0, _i18n.useI18n)();
  var _useState = (0, _react.useState)(false),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    isShowDropMenu = _useState2[0],
    setIsShowDropMenu = _useState2[1];
  var _useState3 = (0, _react.useState)(false),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    disableHover = _useState4[0],
    setDisableHover = _useState4[1];
  (0, _react.useEffect)(function () {
    setDisableHover(userType !== 'normal');
  }, [userType]);
  var userActions = function userActions() {
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "attendee__user-action attendee__user-action-host ".concat(isShowDropMenu ? 'attendee__user-action-hovered' : ''),
      children: [perspectiveType === 'host' ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_action.FcrActionButton, {
        size: "small",
        onClick: function onClick() {
          onParticipantsButtonClick(hasAudio ? ParticipantActionType.MUTE_AUDIO : ParticipantActionType.UNMUTE_AUDIO, userId);
        },
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
          className: hasAudio ? 'attendee__danger-operate' : 'attendee__normal-operate',
          children: hasAudio ? t('fmt_device_label_audio_mute') : isMe ? t('fmt_device_label_audio_unmute') : t('fmt_sip_button_unmute')
        })
      }) : /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        children: isMe ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_action.FcrActionButton, {
          size: "small",
          onClick: function onClick() {
            return onParticipantsButtonClick(hasAudio ? ParticipantActionType.MUTE_AUDIO : ParticipantActionType.UNMUTE_AUDIO, userId);
          },
          children: hasAudio ? t('fmt_device_label_audio_mute') : t('fmt_device_label_audio_unmute')
        }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_action.FcrActionButton, {
          size: "small",
          onClick: function onClick() {
            return onParticipantsButtonClick(ParticipantActionType.PRIVATE_CHAT, userId);
          },
          children: t('fmt_chats_label_privatechat')
        })
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_popover.FcrPopover, {
        visible: isShowDropMenu,
        overlayInnerStyle: {
          border: 0,
          boxShadow: 'var(--fcr_web_light_dropup_m)',
          borderRadius: 'var(--fcr_cornerradius_l)'
        },
        overlayClassName: "attendee__more-actions",
        mouseEnterDelay: 0,
        content: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          onMouseEnter: function onMouseEnter() {
            return setIsShowDropMenu(true);
          },
          onMouseLeave: function onMouseLeave() {
            return setIsShowDropMenu(false);
          },
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_participantsMore.FcrParticipantsMoreActions, {
            isMe: isMe,
            userId: userId,
            userName: userName,
            userRole: userRole,
            hasVideo: hasVideo,
            hasAudio: hasAudio,
            isPin: isPin,
            hasPinnedStream: hasPinnedStream,
            allowedOperations: allowedOperations,
            audioDeviceType: audioDeviceType,
            onParticipantsButtonClick: onParticipantsButtonClick
          })
        }),
        placement: "bottomRight",
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_action.FcrActionButton, {
          onClick: function onClick() {
            return setIsShowDropMenu(true);
          },
          iconType: _type.FcrIconType.FCR_DROPDOWN,
          children: t('fmt_participants_member_button_more')
        })
      })]
    });
  };
  var userAvatar = function userAvatar() {
    if (userType === 'meeting-system') {
      return {
        icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
          type: _type.FcrIconType.FCR_SIPDEVICE,
          colors: {
            iconPrimary: 'var(--fcr_ui_scene_white10)',
            iconSecondary: 'var(--fcr_ui_scene_ramp_green6)'
          }
        }),
        backgroundColor: 'var(--fcr_ui_scene_ramp_purple7)'
      };
    }
    if (userType === 'phone') {
      return {
        icon: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
          type: _type.FcrIconType.FCR_PHONECALL3
        }),
        backgroundColor: 'var(--fcr_ui_scene_ramp_green6)'
      };
    }
    return {
      icon: null,
      backgroundColor: ''
    };
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: (0, _classnames["default"])('attendee', {
      'attendee-active': isShowDropMenu && !disableHover
    }),
    onMouseLeave: function onMouseLeave() {
      return setIsShowDropMenu(false);
    },
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "attendee__user-info",
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_avatar.FcrAvatar, _objectSpread({
        size: 24,
        nickName: userName,
        textSize: 12
      }, userAvatar())), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        className: "attendee__user-info-identity",
        children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          className: "attendee__name",
          children: [userName, isMe && /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
            className: "attendee__me-badge",
            children: ["(", t('fmt_participant_label_Me'), ")"]
          })]
        }), isHost && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: "attendee__host-badge",
          children: t('fmt-role-host')
        })]
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "attendee__user-media",
      children: [isScreenSharing && /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: _type.FcrIconType.FCR_SCREENSHARING_1,
        size: 28,
        colors: {
          iconPrimary: 'var(--fcr_ui_scene_ramp_green6)'
        }
      }), audioDeviceType !== 'none' && /*#__PURE__*/(0, _jsxRuntime.jsx)(_microphoneState.MicrophoneState, {
        isMicrophoneMuted: !hasAudio,
        size: 28,
        isPhoneMic: audioDeviceType === 'phone-mic'
      }), videoDeviceType !== 'none' && /*#__PURE__*/(0, _jsxRuntime.jsx)(_cameraState.CameraState, {
        isCameraMuted: !hasVideo,
        size: 28
      })]
    }), userActions()]
  }, userId);
};