"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrParticipantsFooter = void 0;
require("core-js/modules/es.array.unshift.js");
var _react = _interopRequireDefault(require("react"));
var _button = require("../../button");
var _checkbox = require("../../checkbox");
var _dropMenu = require("../../drop-menu");
var _type = require("../../icon/type");
var _popover = require("../../popover");
require("./index.css");
var _tooltip = require("../../tooltip");
var _i18n = require("../../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var FcrParticipantsFooter = exports.FcrParticipantsFooter = function FcrParticipantsFooter(props) {
  var _props$onRoomControlC = props.onRoomControlClick,
    onRoomControlClick = _props$onRoomControlC === void 0 ? function () {} : _props$onRoomControlC,
    moreDropMenu = props.moreDropMenu;
  var t = (0, _i18n.useI18n)();
  if (props.type === 'attendee') {
    return props.hasRevokeHostPermission ? /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "fcr-participant__footer  fcr-participant__footer-creator",
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_button.FcrButton, {
        type: "secondary-bordered",
        shape: "rounded",
        size: "XS",
        onClick: function onClick() {
          return onRoomControlClick('REVOKE_HOST');
        },
        children: t('fmt_security_options_restract')
      })
    }) : /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {});
  }
  var ParticipantsFooterMore = function ParticipantsFooterMore() {
    var allActions = [{
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_security_buttons_allhandsdown'),
        styleType: "white"
      }),
      key: 'mute_all',
      type: 'disabled',
      onButtonClick: function onButtonClick() {},
      classNames: 'room-control-drop-with-under-line'
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: true,
        label: t('fmt_security_options_silence'),
        styleType: "white"
      }),
      key: 'join_room_with_mute',
      type: 'primary',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('MUTE_ALL_AUDIO');
      }
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_security_options_playnotification'),
        styleType: "white"
      }),
      key: 'play_join_leave_sound',
      type: 'disabled',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('PLAY_JOIN_LEAVE_SOUND');
      }
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_screenshare_controlbar_security_list_lock'),
        styleType: "white"
      }),
      key: 'lock_room',
      type: 'disabled',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('LOCK_ROOM');
      }
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_security_options_activatewaitingroom'),
        styleType: "white"
      }),
      key: 'enable_waiting_room',
      type: 'disabled',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('ENABLE_WAITING_ROOM');
      },
      classNames: 'room-control-drop-with-under-line'
    }, {
      title: t('fmt_screenshare_options_allow'),
      key: 'allow_attendee_title',
      type: 'title'
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_screenshare_controlbar_security_list_participant_unmute'),
        styleType: "white"
      }),
      key: 'unmute_yourself',
      type: 'primary',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('ALLOW_ATTENDEE_TO_UNMUTE');
      }
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_screenshare_controlbar_security_list_participant_changeName'),
        styleType: "white"
      }),
      key: 'rename',
      type: 'disabled',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('RENAME');
      }
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_security_start_video'),
        styleType: "white"
      }),
      key: 'start_video',
      type: 'primary',
      onButtonClick: function onButtonClick() {
        onRoomControlClick('ALLOW_ATTENDEE_TO_OPEN_CAMERA');
      },
      classNames: 'room-control-drop-with-under-line'
    }, {
      title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
        checked: false,
        label: t('fmt_security_options_removemultiple'),
        styleType: "white"
      }),
      key: 'remove_fcr-participants',
      type: 'danger',
      onButtonClick: function onButtonClick() {},
      classNames: 'room-control-drop-disable'
    }];
    if (props.hasRevokeHostPermission) {
      allActions.unshift({
        title: /*#__PURE__*/(0, _jsxRuntime.jsx)(_checkbox.FcrCheckbox, {
          checked: false,
          label: t('fmt_security_options_restract'),
          styleType: "white"
        }),
        key: 'revoke_host',
        type: 'primary',
        onButtonClick: function onButtonClick() {
          onRoomControlClick('REVOKE_HOST');
        },
        classNames: 'room-control-drop-with-under-line'
      });
    }
    return /*#__PURE__*/(0, _jsxRuntime.jsx)(_dropMenu.FcrDropMenu, {
      options: allActions
    });
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: "fcr-participant__footer",
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip.FcrToolTip, {
      content: t('fmt_participants_options_allmute'),
      mouseEnterDelay: 0,
      trigger: "hover",
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_button.FcrButton, {
        type: "secondary-bordered",
        size: "XS",
        onClick: function onClick() {
          return onRoomControlClick('MUTE_ALL_AUDIO');
        },
        children: t('fmt_participants_options_allmute')
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip.FcrToolTip, {
      content: t('fmt_participants_options_allunmute'),
      mouseEnterDelay: 0,
      trigger: "hover",
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_button.FcrButton, {
        type: "secondary-bordered",
        size: "XS",
        onClick: function onClick() {
          return onRoomControlClick('UNMUTE_ALL_AUDIO');
        },
        children: t('fmt_participants_button_unmuteAll')
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_popover.FcrPopover, {
      trigger: "click",
      overlayClassName: "attendee__footer-more-actions",
      mouseEnterDelay: 0,
      overlayInnerStyle: {
        boxShadow: 'none',
        border: 'none',
        width: '256px'
      },
      content: moreDropMenu ? moreDropMenu : /*#__PURE__*/(0, _jsxRuntime.jsx)(ParticipantsFooterMore, {}),
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_button.FcrButton, {
        type: "secondary-bordered",
        size: "XS",
        postIcon: _type.FcrIconType.FCR_DROPDOWN,
        children: t('fmt_participants_button_meetingManagement')
      })
    })]
  });
};