import { FC, ReactNode } from 'react';
import { ToolTipProps } from '../tooltip';
import './index.css';
export interface PopoverProps extends ToolTipProps {
    /**
     * 气泡操作面板的尺寸，可选值为 large | small
     */
    /** @en
     * The size of popover dialog, can be set to large | small.
     */
    size?: 'large' | 'small';
    afterVisibleChange?: (visible: boolean) => void;
}
export declare const FcrPopover: FC<PopoverProps>;
interface DoubleDeckPopoverProps extends ToolTipProps {
    /**
     * popover上部分的内容
     */
    /** @en
     * The content of deck on top of the popover dialog.
     */
    topDeckContent?: ReactNode;
    /**
     * popover下部分的内容
     */
    /** @en
     * The content of deck on bottom of the popover dialog.
     */
    bottomDeckContent?: ReactNode;
}
export declare const DoubleDeckPopover: FC<DoubleDeckPopoverProps>;
interface FcrPopoverWithTooltip {
    popoverProps?: PopoverProps;
    toolTipProps?: ToolTipProps;
    triggerCls?: string;
}
export declare const PopoverWithTooltip: import("react").ForwardRefExoticComponent<FcrPopoverWithTooltip & {
    children: ReactNode;
} & import("react").RefAttributes<{
    closePopover: () => void;
}>>;
interface FcrDoubleDeckPopoverWithTooltip {
    doulebDeckPopoverProps?: DoubleDeckPopoverProps;
    toolTipProps?: ToolTipProps;
}
export declare const DoubleDeckPopoverWithTooltip: FC<React.PropsWithChildren<FcrDoubleDeckPopoverWithTooltip>>;
export {};
