"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.More = void 0;
require("core-js/modules/es.array.map.js");
require("core-js/modules/esnext.async-iterator.map.js");
require("core-js/modules/esnext.iterator.map.js");
var _i18n = require("../../../i18n");
var _divider = _interopRequireDefault(require("../../divider"));
var _icon = require("../../icon");
var _type = require("../../icon/type");
var _popover = require("../../popover");
var _tooltip = require("../../tooltip");
require("./index.css");
var _jsxRuntime = require("react/jsx-runtime");
var More = exports.More = function More(props) {
  var t = (0, _i18n.useI18n)();
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: "share-action-nav__button share-action-nav__not-draggable share-action-nav__single-button",
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_popover.FcrPopover, {
      overlayClassName: "share-action-nav__popover",
      visible: props.visible,
      content: props.morePopoverContent ? props.morePopoverContent : /*#__PURE__*/(0, _jsxRuntime.jsx)(MorePopoverContent, {}),
      overlayInnerStyle: {
        border: 0,
        boxShadow: 'var(--fcr_web_light_dropup_m)',
        borderRadius: 'var(--fcr_cornerradius_l)'
      },
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip.FcrToolTip
      //todo 容易遮挡结束共享按钮，暂时隐藏tooltip
      , {
        visible: false,
        content: t('fmt_participants_member_button_more'),
        trigger: "hover",
        placement: "top",
        mouseEnterDelay: 0,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: "share-action-nav__action-button",
          onClick: props.onButtonClick,
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
            type: _type.FcrIconType.FCR_MOBILE_MORE,
            size: 32,
            colors: {
              iconPrimary: 'var(--fcr_web_ui_scene_mainicon1)'
            }
          })
        })
      })
    })
  });
};
var MeetingItemRole = /*#__PURE__*/function (MeetingItemRole) {
  MeetingItemRole[MeetingItemRole["ALL"] = 0] = "ALL";
  MeetingItemRole[MeetingItemRole["HOST"] = 1] = "HOST";
  MeetingItemRole[MeetingItemRole["GUEST"] = 2] = "GUEST";
  return MeetingItemRole;
}(MeetingItemRole || {});
var MorePopoverContent = function MorePopoverContent() {
  var t = (0, _i18n.useI18n)();
  var moreOptions = [{
    type: 'item',
    icon: _type.FcrIconType.FCR_CHAT,
    text: t('fmt_chat_label_chat'),
    showRole: MeetingItemRole.ALL,
    key: 'chat'
  }, {
    type: 'item',
    icon: _type.FcrIconType.FCR_EMO,
    text: t('fmt_popup_label_expression'),
    showRole: MeetingItemRole.ALL,
    key: 'emoji'
  }, {
    type: 'divider',
    showRole: MeetingItemRole.ALL,
    key: 'divider'
  }, {
    type: 'item',
    icon: null,
    text: t('fmt_record_button_Localrecording'),
    showRole: MeetingItemRole.ALL,
    key: 'localRecord'
  }, {
    type: 'item',
    icon: null,
    text: t('fmt_record_button_Cloudrecording'),
    showRole: MeetingItemRole.ALL,
    key: 'cloudRecord'
  }];
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: "share-action-nav__popover-inner-content share-action-nav__not-draggable",
    children: moreOptions.map(function (item, index) {
      return item.type === 'item' ? /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: "share-action-nav__media-list-group",
        children: /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
          className: "fcr-flex fcr-items-center share-action-nav__popover-option-media-setting share-action-nav__popover-option",
          children: [item.icon ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
            type: _type.FcrIconType.FCR_SETTING,
            size: 24,
            colors: {
              iconPrimary: 'var(--fcr_ui_scene_icontext5)'
            }
          }, item.key) : /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
            className: "icon-placeholder-symbol"
          }), /*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
            children: t('fmt_settings_option_setting')
          })]
        })
      }, item.key) : /*#__PURE__*/(0, _jsxRuntime.jsx)(_divider["default"], {
        type: "horizontal",
        style: {
          margin: '8px 0'
        }
      }, "divider_".concat(index));
    })
  });
};