"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ShareActionNav = void 0;
var _i18n = require("../../../i18n");
var _divider = _interopRequireDefault(require("../../divider"));
var _type = require("../../icon/type");
var _tooltipsButton = require("../../tooltips-button");
var _device = require("../device");
var _meetingSecurity = require("../meeting-security");
var _more = require("../more");
var _participants = require("../participants");
var _shareAudio = require("../share-audio");
require("./index.css");
var _jsxRuntime = require("react/jsx-runtime");
var ShareActionNav = exports.ShareActionNav = function ShareActionNav(props) {
  var t = (0, _i18n.useI18n)();
  var className = props.className,
    _props$onMicrophoneDe = props.onMicrophoneDevicePopoverVisibleChange,
    onMicrophoneDevicePopoverVisibleChange = _props$onMicrophoneDe === void 0 ? function () {} : _props$onMicrophoneDe,
    _props$onCameraDevice = props.onCameraDevicePopoverVisibleChange,
    onCameraDevicePopoverVisibleChange = _props$onCameraDevice === void 0 ? function () {} : _props$onCameraDevice;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: "share-action-nav share-action-nav__can-draggable ".concat(className),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "share-action-nav__media-control-group",
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_device.MicrophoneDevice, {
        onMicrophoneDevicePopoverVisibleChange: onMicrophoneDevicePopoverVisibleChange
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_device.CameraDevice, {
        onCameraDevicePopoverVisibleChange: onCameraDevicePopoverVisibleChange
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_divider["default"], {
      style: {
        marginRight: 24,
        height: '20px',
        marginLeft: 30
      }
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "share-action-nav__meeting-control-group",
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_meetingSecurity.MeetingSecurity, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(_participants.ParticipantButton, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(_divider["default"], {
        style: {
          margin: '0 8px',
          height: '20px'
        }
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltipsButton.FrcTooltipButton, {
        tooltip: {
          content: t('fmt_screenshare_controlbar_button_newScreenshare'),
          icon: {
            type: _type.FcrIconType.FCR_SCREENSHARING_1,
            size: 32,
            colors: {
              iconPrimary: 'var(--fcr_web_ui_scene_mainicon1)'
            }
          }
        },
        withPopover: false
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_more.More, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(_divider["default"], {
        style: {
          margin: '0 8px',
          height: '20px'
        }
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_shareAudio.ShareAudio, {
        shareWithAudio: false
      })]
    })]
  });
};