"use strict";

require("core-js/modules/es.object.define-property.js");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ShareStateNav = exports.DragIcon = void 0;
var _i18n = require("../../../i18n");
var _icon = require("../../icon");
var _type = require("../../icon/type");
var _tooltip = require("../../tooltip");
var _microphoneState = require("../microphone-state");
var _transferPositionIcon = require("../transfer-position-icon");
require("./index.css");
var _jsxRuntime = require("react/jsx-runtime");
var DragIcon = exports.DragIcon = function DragIcon() {
  var t = (0, _i18n.useI18n)();
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_tooltip.FcrToolTip, {
    content: t('fmt_popup_button_drag'),
    trigger: "hover",
    mouseEnterDelay: 0,
    children: /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "share-state-nav__drag-button",
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: _type.FcrIconType.FCR_WHITEBOARD_MOVE,
        className: "share-state-nav__drag-icon",
        colors: {
          iconPrimary: 'var(--fcr_ui_scene_black8)'
        },
        size: 20
      })
    })
  });
};
var ShareStateNav = exports.ShareStateNav = function ShareStateNav(props) {
  var onShareStateNavTransferPosition = props.onShareStateNavTransferPosition,
    currentPosition = props.currentPosition;
  var t = (0, _i18n.useI18n)();
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: "share-state-nav fcr-flex fcr-items-center \n                 fcr-justify-center share-action-nav__can-draggable \n                ".concat(currentPosition === _transferPositionIcon.TransferPosition.TOP ? 'share-state-nav-top' : 'share-state-nav-bottom'),
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(DragIcon, {}), /*#__PURE__*/(0, _jsxRuntime.jsx)(_transferPositionIcon.TransferPositionIcon, {
      onTransferPositionButtonClick: onShareStateNavTransferPosition,
      currentPosition: currentPosition
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "share-state-nav__state-text",
      children: t('fmt_settings_tips_sharing')
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_microphoneState.MicrophoneState, {
      isMicrophoneMuted: true
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "share-state-nav__meeting-elapsed-time",
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)("span", {
        children: "00:10:00"
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("span", {
        children: ["(", t('fmt_settings_labels_miniutes', {
          reason1: 60
        }), ")"]
      })]
    }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "share-state-nav__stop-share fcr-flex fcr-items-center fcr-justify-center",
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: _type.FcrIconType.FCR_RECORDING_STOP,
        size: 20,
        colors: {
          iconPrimary: 'var(--fcr_ui_scene_white10)'
        }
      }), t('fmt_screenshare_controlbar_button_stop')]
    })]
  });
};