import { FC } from 'react';
import './index.css';
type SliderProps = {
    /**
     * 设置初始取值。
     */
    /** @en
     * default value
     */
    defaultValue?: number;
    /**
     * 设置当前取值
     */
    /** @en
     * current value
     */
    value?: number;
    /**
     * 最小值
     */
    /** @en
     * min
     */
    min?: number;
    /**
     * 最大值
     */
    /** @en
     * max
     */
    max?: number;
    /**
     * 步长，取值必须大于 0，并且可被 (max - min) 整除。
     */
    /** @en
     * The step size, which must be greater than 0 and divisible by (max - min).
     */
    step?: number;
    /**
     * 当 Slider 的值发生改变时，会触发 onChange 事件，并把改变后的值作为参数传入
     */
    /** @en
     * When the value of the Slider changes, the onChange event is triggered and the changed value is passed as a parameter to the
     */
    onChange?: (val: number) => any;
    draggableDom?: HTMLDivElement | Document;
    disabled?: boolean;
};
export declare const FcrSlider: FC<SliderProps>;
export {};
