"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MeetingTime = exports.MeetingStatus = void 0;
require("./index.css");
var _view = require("./view");
var _clsx = _interopRequireDefault(require("clsx"));
var _useNamespace = require("../../utilities/use-namespace");
var _icon = require("../icon");
var _type = require("../icon/type");
var _i18n = require("../../i18n");
var _jsxRuntime = require("react/jsx-runtime");
var MeetingStatus = exports.MeetingStatus = /*#__PURE__*/function (MeetingStatus) {
  MeetingStatus["NORMAL"] = "normal";
  MeetingStatus["SOON_TO_END"] = "soon2end";
  MeetingStatus["OVERTIME"] = "overtime";
  return MeetingStatus;
}({});
var MeetingTime = exports.MeetingTime = function MeetingTime(props) {
  var ns = (0, _useNamespace.useNamespace)('meeting-time');
  var transI18n = (0, _i18n.useI18n)();
  // const currentTime = '59:59';
  // const total = 60;
  // const status: MeetingStatus = MeetingStatus.SOON_TO_END;
  var t = (0, _i18n.useI18n)();
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_view.MyFcrToolTip, {
    content: t('fmt_statusbar_label_durationtime', {
      reason1: props.total,
      reason2: t('fmt_statusbar_label_minutes')
    }),
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: (0, _clsx["default"])(ns.b(), ns.m(props.status)),
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: _type.FcrIconType.FCR_CLOCK,
        className: ns.e('icon'),
        size: 22
      }), /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
        children: [props.currentTime, "(", props.total, "mins)"]
      })]
    })
  });
};