import { FC } from 'react';
import './mobile.css';
type FcrMobileSwitchProps = {
    /**
     * 开关状态的标签
     * { on: '开', off: '关' }
     */
    /** @en
     * Labels for the switch's states
     */
    labels?: Record<'on' | 'off', string>;
    /**
     * 开关的值
     */
    /** @en
     * Value of the switch
     */
    value?: boolean;
    /**
     * 值变更事件
     * @param value 变更值
     */
    /** @en
     * Change event of the switch's value
     * @param value changed value
     */
    onChange?: (val: boolean) => void;
};
export declare const FcrMobileSwitch: FC<FcrMobileSwitchProps>;
export {};
