"use strict";

require("core-js/modules/es.object.define-property.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrTabs = exports.FcrFashionTabs = void 0;
require("core-js/modules/es.array.map.js");
require("core-js/modules/esnext.async-iterator.map.js");
require("core-js/modules/esnext.iterator.map.js");
var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));
var _classnames = _interopRequireDefault(require("classnames"));
var _react = require("react");
require("./index.css");
var _icon = require("../icon");
var _type = require("../icon/type");
var _jsxRuntime = require("react/jsx-runtime");
var FcrTabs = exports.FcrTabs = function FcrTabs(_ref) {
  var _ref$items = _ref.items,
    items = _ref$items === void 0 ? [] : _ref$items,
    activeKey = _ref.activeKey,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
    variant = _ref.variant;
  var _useState = (0, _react.useState)({}),
    _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
    indicatorStyle = _useState2[0],
    setIndicatorStyle = _useState2[1];
  var selectorRef = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    var _selectorRef$current;
    var el = (_selectorRef$current = selectorRef.current) === null || _selectorRef$current === void 0 ? void 0 : _selectorRef$current.querySelector(".fcr-tabs__nav-item-".concat(activeKey));
    if (el) {
      var _ref2 = el,
        offsetLeft = _ref2.offsetLeft;
      setIndicatorStyle({
        left: offsetLeft,
        width: el.clientWidth
      });
    }
  }, [activeKey]);
  var cls = (0, _classnames["default"])('fcr-tabs', {
    'fcr-simple-tabs': variant === 'simple'
  });
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: cls,
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "fcr-tabs__nav-list",
      ref: selectorRef,
      children: [items.map(function (_ref3) {
        var label = _ref3.label,
          key = _ref3.key;
        var cls = (0, _classnames["default"])("fcr-tabs__nav-item fcr-tabs__nav-item-".concat(key), {
          'fcr-tabs__nav-item--active': key === activeKey
        });
        var handleClick = function handleClick() {
          onChange(key);
        };
        return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: cls,
          onClick: handleClick,
          children: label
        }, key);
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: "fcr-tabs__nav-indicator",
        style: indicatorStyle
      })]
    })
  });
};
var FcrFashionTabs = exports.FcrFashionTabs = function FcrFashionTabs(_ref4) {
  var _ref4$items = _ref4.items,
    items = _ref4$items === void 0 ? [] : _ref4$items,
    activeKey = _ref4.activeKey,
    _ref4$onChange = _ref4.onChange,
    onChange = _ref4$onChange === void 0 ? function () {} : _ref4$onChange;
  var rootRef = (0, _react.useRef)(null);
  var _useState3 = (0, _react.useState)({}),
    _useState4 = (0, _slicedToArray2["default"])(_useState3, 2),
    indicatorStyle = _useState4[0],
    setIndicatorStyle = _useState4[1];
  (0, _react.useEffect)(function () {
    if (!rootRef.current) {
      return;
    }
    var el = rootRef.current.querySelector(".fcr-tabs__nav-item-".concat(activeKey));
    if (el) {
      var _ref5 = el,
        offsetLeft = _ref5.offsetLeft;
      setIndicatorStyle({
        left: offsetLeft + el.clientWidth - 40,
        width: 40,
        top: -7
      });
    }
  }, [activeKey, items]);
  return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
    className: "fcr-tabs fcr-fashion-tabs",
    ref: rootRef,
    children: /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
      className: "fcr-tabs__nav-list",
      children: [items.map(function (_ref6) {
        var label = _ref6.label,
          key = _ref6.key;
        var cls = (0, _classnames["default"])("fcr-tabs__nav-item fcr-tabs__nav-item-".concat(key), {
          'fcr-tabs__nav-item--active': key === activeKey
        });
        var handleClick = function handleClick() {
          onChange(key);
        };
        return /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
          className: cls,
          onClick: handleClick,
          children: label
        }, key);
      }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
        className: "fcr-fashion-tabs__nav-indicator",
        style: indicatorStyle,
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
          type: _type.FcrIconType.FCR_UNDERLINE,
          colors: {
            iconPrimary: 'var(--fcr_ui_scene_icontext2)'
          },
          size: 40
        })
      })]
    })
  });
};