"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrDialogToolTip = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
require("rc-tooltip/assets/bootstrap_white.css");
require("./index.css");
require("./arrow.css");
var _ = require(".");
var _classnames = _interopRequireDefault(require("classnames"));
var _icon = require("../icon");
var _type = require("../icon/type");
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["content", "onClose", "closeable"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var DialogToolTipClosableOverlayWrap = function DialogToolTipClosableOverlayWrap(props) {
  var content = props.content,
    onClose = props.onClose,
    closeable = props.closeable;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    className: (0, _classnames["default"])('fcr-dialog-tooltip-overlay-content'),
    children: [closeable && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: (0, _classnames["default"])('fcr-dialog-tooltip-overlay-close'),
      onClick: onClose,
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
        type: _type.FcrIconType.FCR_CLOSE,
        size: 10
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: (0, _classnames["default"])('fcr-dialog-tooltip-overlay-content-inner'),
      children: content
    })]
  });
};
var FcrDialogToolTip = exports.FcrDialogToolTip = function FcrDialogToolTip(props) {
  var content = props.content,
    onClose = props.onClose,
    _props$closeable = props.closeable,
    closeable = _props$closeable === void 0 ? true : _props$closeable,
    others = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var defaultDialogOverlayInnerStyle = {
    padding: '0',
    background: "var(--fcr_mobile_ui_scene_color_popup_fill1)",
    border: "2px solid var(--fcr_ui_scene_line2)",
    color: "var(--fcr_ui_scene_icontext1)",
    borderRadius: "var(--fcr_cornerradius_xs)",
    boxShadow: 'none'
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_.FcrToolTip, _objectSpread(_objectSpread({
    arrowContent: /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      type: _type.FcrIconType.FCR_TOOLTIP_ARROW_2,
      colors: {
        iconPrimary: 'var(--fcr_mobile_ui_scene_color_popup_fill1)',
        iconSecondary: 'var(--fcr_ui_scene_line2)'
      },
      size: 20
    }),
    content: /*#__PURE__*/(0, _jsxRuntime.jsx)(DialogToolTipClosableOverlayWrap, {
      onClose: onClose,
      content: content,
      closeable: closeable
    }),
    overlayInnerStyle: _objectSpread(_objectSpread({}, defaultDialogOverlayInnerStyle), props.overlayInnerStyle)
  }, others), {}, {
    overlayClassName: "fcr-dialog-tooltip fcr-tooltip-border-width-2 ".concat(others.overlayClassName || '')
  }));
};