import { CSSMotionProps } from 'rc-motion';
import { CSSProperties, FC, ReactNode } from 'react';
import './index.css';
import './arrow.css';
import React from 'react';
type ToolTipActionType = 'hover' | 'focus' | 'click' | 'contextMenu';
export interface ToolTipProps {
    /**
     * 卡片内容
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    content?: ReactNode;
    /**
     * 触发行为，可选 hover | focus | click | contextMenu
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    trigger?: ToolTipActionType;
    /**
     * 气泡框位置，可选 top left right bottom topLeft topRight bottomLeft bottomRight leftTop leftBottom rightTop rightBottom
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    placement?: 'top' | 'left' | 'right' | 'bottom' | 'topLeft' | 'topRight' | 'bottomLeft' | 'bottomRight' | 'leftTop' | 'leftBottom' | 'rightTop' | 'rightBottom';
    /**
     * 自定义箭头
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    arrowContent?: ReactNode;
    /**
     * 卡片内容区域的样式对象
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    overlayInnerStyle?: CSSProperties;
    /**
     * 气泡的显示状态
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    visible?: boolean;
    /**
     * 卡片类名
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    overlayClassName?: string;
    /**
     * 修改箭头的显示状态
     */
    /** @en
     * Size of the input box:
     * medium
     * large
     */
    showArrow?: boolean;
    onVisibleChange?: (visible: boolean) => void;
    motion?: CSSMotionProps;
    getTooltipContainer?: (node: HTMLElement) => HTMLElement;
    children?: React.ReactNode;
    mouseEnterDelay?: number;
    overlayOffset?: number;
    mouseLeaveDelay?: number;
    afterVisibleChange?: (visible: boolean) => void;
}
export declare const FcrToolTip: FC<ToolTipProps>;
export {};
