"use strict";

require("core-js/modules/es.symbol.js");
require("core-js/modules/es.array.filter.js");
require("core-js/modules/es.array.for-each.js");
require("core-js/modules/es.array.push.js");
require("core-js/modules/es.object.define-properties.js");
require("core-js/modules/es.object.define-property.js");
require("core-js/modules/es.object.get-own-property-descriptor.js");
require("core-js/modules/es.object.get-own-property-descriptors.js");
require("core-js/modules/es.object.keys.js");
require("core-js/modules/es.object.to-string.js");
require("core-js/modules/esnext.async-iterator.filter.js");
require("core-js/modules/esnext.async-iterator.for-each.js");
require("core-js/modules/esnext.iterator.constructor.js");
require("core-js/modules/esnext.iterator.filter.js");
require("core-js/modules/esnext.iterator.for-each.js");
require("core-js/modules/web.dom-collections.for-each.js");
var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FcrToolTip = void 0;
var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));
var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));
require("core-js/modules/es.array.includes.js");
require("core-js/modules/es.string.includes.js");
var _rcTooltip = _interopRequireDefault(require("rc-tooltip"));
require("./index.css");
require("./arrow.css");
var _icon = require("../icon");
var _type = require("../icon/type");
var _react = _interopRequireDefault(require("react"));
var _jsxRuntime = require("react/jsx-runtime");
var _excluded = ["content", "children", "trigger", "placement", "arrowContent", "overlayInnerStyle", "overlayClassName", "showArrow", "onVisibleChange", "motion", "getTooltipContainer", "mouseEnterDelay", "mouseLeaveDelay", "overlayOffset", "afterVisibleChange"];
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { (0, _defineProperty2["default"])(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
var calcOverlayOffset = function calcOverlayOffset(placement, offset) {
  if (placement.includes('top')) {
    return [0, -offset];
  }
  if (placement.includes('bottom')) {
    return [0, offset];
  }
  if (placement.includes('left')) {
    return [-offset, 0];
  }
  if (placement.includes('right')) {
    return [offset, 0];
  }
};
var FcrToolTip = exports.FcrToolTip = function FcrToolTip(props) {
  var content = props.content,
    children = props.children,
    trigger = props.trigger,
    _props$placement = props.placement,
    placement = _props$placement === void 0 ? 'top' : _props$placement,
    arrowContent = props.arrowContent,
    overlayInnerStyle = props.overlayInnerStyle,
    overlayClassName = props.overlayClassName,
    _props$showArrow = props.showArrow,
    showArrow = _props$showArrow === void 0 ? true : _props$showArrow,
    onVisibleChange = props.onVisibleChange,
    motion = props.motion,
    getTooltipContainer = props.getTooltipContainer,
    mouseEnterDelay = props.mouseEnterDelay,
    mouseLeaveDelay = props.mouseLeaveDelay,
    _props$overlayOffset = props.overlayOffset,
    overlayOffset = _props$overlayOffset === void 0 ? 12 : _props$overlayOffset,
    afterVisibleChange = props.afterVisibleChange,
    others = (0, _objectWithoutProperties2["default"])(props, _excluded);
  var defaultOverlayInnerStyle = {
    padding: '7px 10px',
    background: "var(--fcr_ui_scene_inverse2)",
    border: "1px solid var(--fcr_ui_scene_inverse2)",
    fontStyle: 'normal',
    fontWeight: 'var(--fcr_font_weight_s)',
    fontSize: '14px',
    lineHeight: '130%',
    color: "var(--fcr_ui_scene_inverse)",
    borderRadius: "var(--fcr_cornerradius_l)",
    boxShadow: '0px 4px 4px 0px rgba(0, 0, 0, 0.25)',
    textAlign: 'center'
  };
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(_rcTooltip["default"], _objectSpread(_objectSpread({
    destroyTooltipOnHide: true,
    afterVisibleChange: afterVisibleChange,
    mouseLeaveDelay: mouseLeaveDelay,
    mouseEnterDelay: mouseEnterDelay !== null && mouseEnterDelay !== void 0 ? mouseEnterDelay : 1,
    getTooltipContainer: getTooltipContainer,
    onVisibleChange: onVisibleChange,
    prefixCls: "fcr-tooltip",
    overlayClassName: overlayClassName,
    arrowContent: showArrow === false ? null : arrowContent || /*#__PURE__*/(0, _jsxRuntime.jsx)(_icon.FcrIcon, {
      colors: {
        iconPrimary: 'var(--fcr_ui_scene_inverse2)'
      },
      type: _type.FcrIconType.FCR_TOOLTIP_ARROW,
      size: 16
    }),
    align: {
      offset: calcOverlayOffset(placement, overlayOffset)
    },
    trigger: trigger,
    placement: placement,
    overlay: content,
    overlayInnerStyle: _objectSpread(_objectSpread({}, defaultOverlayInnerStyle), overlayInnerStyle),
    motion: motion || {
      motionAppear: true,
      motionName: 'fcr-tooltip-anim'
    }
  }, others), {}, {
    children: children || /*#__PURE__*/(0, _jsxRuntime.jsx)(_jsxRuntime.Fragment, {})
  }));
};