import React from 'react';
import { PathOptions } from '../icon/svg-dict';
import { FcrIconType } from '../icon/type';
import './tooltip-button.css';
interface FrcTooltipButtonToolTipProps {
    icon?: {
        type: FcrIconType;
        colors: Partial<PathOptions>;
        size: number;
    };
    trigger?: 'hover' | 'click';
    placement?: 'top' | 'bottom' | 'left' | 'right';
    content?: React.ReactNode;
}
interface FrcTooltipButtonPopoverProps extends FrcTooltipButtonToolTipProps {
    onPopoverOptionClick?: () => void;
    onVisibleChange?: (visible: boolean) => void;
    visible?: boolean;
}
export interface FrcTooltipButtonProps {
    classNames?: {
        container?: string;
        button?: string;
        tooltip?: string;
        popover?: string;
    };
    tooltip: FrcTooltipButtonToolTipProps;
    withPopover?: boolean;
    popover?: FrcTooltipButtonPopoverProps;
    children?: React.ReactNode;
    onTooltipButtonClick?: () => void;
}
export declare const FrcTooltipButton: (props: FrcTooltipButtonProps) => import("react/jsx-runtime").JSX.Element;
export {};
