import { FC, ChangeEvent } from 'react';
import './index.css';
export type SelectStyleType = 'white';
export type SelectProps = {
    /**
     * 下拉框的提示符
     */
    /** @en
     * Placeholder of the select
     */
    placeholder?: string;
    /**
     * 区域下拉框选项
     */
    /** @en
     * The select options
     */
    zoneOptions?: {
        text: string;
        value: string;
    }[];
    /**
     * 区域下拉框选项
     */
    /** @en
     * The select options
     */
    phoneOptions?: {
        text: string;
        value: string;
    }[];
    /**
     * 输入框的尺寸：
     * small - 小
     * medium - 中等(default)
     * large - 大
     */
    /** @en
     * Size of the select:
     * small
     * medium
     * large
     */
    size?: 'large' | 'medium' | 'small';
    /**
     * 下拉框样式类型，可选值为 'white'
     */
    /** @en
     * Set the style type of select, can be set to 'white'.
     */
    styleType?: SelectStyleType;
    /** 选择值变化
     * Change event of the input's value
     *
     */
    onChange?: (zone: string, phone: string) => void;
    /**
     *
     *输入框失去焦点变化
     */
    onInputBlur?: (e: ChangeEvent<HTMLInputElement>) => void;
    /**
     *
     *输入框值变化
     */
    onInputChange?: (e: ChangeEvent<HTMLInputElement>) => void;
    /**
     * 下拉框是否禁用
     */
    /** @en
     * Whether the select is disabled
     */
    disabled?: boolean;
    /**
     * zoneDefault
     */
    /** @en
     * Whether the select is disabled
     */
    zoneDefault?: string;
    /**
     * phoneDefault
     */
    /** @en
     * Whether the select is disabled
     */
    phoneDefault?: string;
    /**
     * maxlength
     */
    /** @en
     * phone input maxlength
     */
    maxlength?: string;
};
export declare const FcrZonePhone: FC<SelectProps>;
